/**
  ******************************************************************************
  * @file    bsp_i2c_ee.c
  * @author  armfly (ʽ)
  * @version V1.0
  * @date    2013-xx-xx
  * @brief   i2c EEPROM(AT24C02)Ӧúbsp
  ******************************************************************************
  * @attention
  *
  * ʵƽ̨:Ұ ISO-MINI STM32  
  * ̳    :http://www.chuxue123.com
  * Ա    :http://firestm32.taobao.com
  *
  ******************************************************************************
  */ 

#include "bsp_i2c_ee.h"
#include "bsp_i2c_gpio.h"
#include "bsp_usart1.h" 
#include "types.h"
/*
*********************************************************************************************************
*	  : ee_CheckOk
*	˵: жϴEERPOMǷ
*	    Σ
*	  ֵ: 1 ʾ 0 ʾ
*********************************************************************************************************
*/
uint8_t ee_CheckOk(void)
{
	if (i2c_CheckDevice(EE_DEV_ADDR) == 0)
	{
		return 1;
	}
	else
	{
		/* ʧܺмǷI2Cֹͣź */
		i2c_Stop();		
		return 0;
	}
}

/*
*********************************************************************************************************
*	  : ee_ReadBytes
*	˵: ӴEEPROMַָʼȡ
*	    Σ_usAddress : ʼַ
*			 _usSize : ݳȣλΪֽ
*			 _pReadBuf : ŶݵĻָ
*	  ֵ: 0 ʾʧܣ1ʾɹ
*********************************************************************************************************
*/
uint8_t ee_ReadBytes(uint8_t *_pReadBuf, uint16_t _usAddress, uint16_t _usSize)
{
	uint16_t i;
	
	/* ôEEPROM漴ȡָУȡֽ */
	
	/* 1I2Cź */
	i2c_Start();
	
	/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
	i2c_SendByte(EE_DEV_ADDR | I2C_WR);	/* ˴дָ */
	
	/* 3ACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* EEPROMӦ */
	}

	/* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
	i2c_SendByte((uint8_t)_usAddress);
	
	/* 5ACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* EEPROMӦ */
	}
	
	/* 6I2CߡǰĴĿEEPROM͵ַ濪ʼȡ */
	i2c_Start();
	
	/* 7ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
	i2c_SendByte(EE_DEV_ADDR | I2C_RD);	/* ˴Ƕָ */
	
	/* 8ACK */
	if (i2c_WaitAck() != 0)
	{
		goto cmd_fail;	/* EEPROMӦ */
	}	
	
	/* 9ѭȡ */
	for (i = 0; i < _usSize; i++)
	{
		_pReadBuf[i] = i2c_ReadByte();	/* 1ֽ */
		
		/* ÿ1ֽںҪAck һֽڲҪAckNack */
		if (i != _usSize - 1)
		{
			i2c_Ack();	/* мֽڶCPUACKź(SDA = 0) */
		}
		else
		{
			i2c_NAck();	/* 1ֽڶCPUNACKź(SDA = 1) */
		}
	}
	/* I2Cֹͣź */
	i2c_Stop();
	return 1;	/* ִгɹ */

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 0;
}

/*
*********************************************************************************************************
*	  : ee_WriteBytes
*	˵: EEPROMַָдݣҳддЧ
*	    Σ_usAddress : ʼַ
*			 _usSize : ݳȣλΪֽ
*			 _pWriteBuf : ŶݵĻָ
*	  ֵ: 0 ʾʧܣ1ʾɹ
*********************************************************************************************************
*/
uint8_t ee_WriteBytes(uint8_t *_pWriteBuf, uint16_t _usAddress, uint16_t _usSize)
{
	uint16_t i,m;
	uint16_t usAddr;
	
	/* 
		дEEPROMȡֽܶڣÿдֻͬһpage
		24xx02page size = 8
		򵥵ĴΪֽдģʽûд1ֽڣ͵ַ
		ΪдЧ: page wirte
	*/

	usAddr = _usAddress;	
	for (i = 0; i < _usSize; i++)
	{
		/* ͵1ֽڻҳ׵ַʱҪ·źź͵ַ */
		if ((i == 0) || (usAddr & (EE_PAGE_SIZE - 1)) == 0)
		{
			/*ڣֹͣźţڲд*/
			i2c_Stop();
			
			/* ͨӦķʽжڲдǷ, һС 10ms 			
				CLKƵΪ200KHzʱѯΪ30
			*/
			for (m = 0; m < 100; m++)
			{				
				/* 1I2Cź */
				i2c_Start();
				
				/* 2ֽڣ7bitǵַbit0Ƕдλ0ʾд1ʾ */
				i2c_SendByte(EE_DEV_ADDR | I2C_WR);	/* ˴дָ */
				
				/* 3һʱӣжǷȷӦ */
				if (i2c_WaitAck() == 0)
				{
					break;
				}
			}
			if (m  == 1000)
			{
				goto cmd_fail;	/* EEPROMдʱ */
			}
		
			/* 4ֽڵַ24C02ֻ256ֽڣ1ֽھ͹ˣ24C04ϣô˴Ҫַ */
			i2c_SendByte((uint8_t)usAddr);
			
			/* 5ACK */
			if (i2c_WaitAck() != 0)
			{
				goto cmd_fail;	/* EEPROMӦ */
			}
		}
	
		/* 6ʼд */
		i2c_SendByte(_pWriteBuf[i]);
	
		/* 7ACK */
		if (i2c_WaitAck() != 0)
		{
			goto cmd_fail;	/* EEPROMӦ */
		}

		usAddr++;	/* ַ1 */		
	}
	
	/* ִгɹI2Cֹͣź */
	i2c_Stop();
	return 1;

cmd_fail: /* ִʧܺмǷֹͣźţӰI2C豸 */
	/* I2Cֹͣź */
	i2c_Stop();
	return 0;
}

void ee_Erase(void)
{
	uint16_t i;
	uint8_t buf[EE_SIZE];
	
	/* 仺 */
	for (i = 0; i < EE_SIZE; i++)
	{
		buf[i] = 0xFF;
	}
	
	/* дEEPROM, ʼַ = 0ݳΪ 256 */
	if (ee_WriteBytes(buf, 0, EE_SIZE) == 0)
	{
		printf("eeprom\r\n");
		return;
	}
	else
	{
		printf("eepromɹ\r\n");
	}
}


/*--------------------------------------------------------------------------------------------------*/

static void ee_Delay(__IO uint32_t nCount)	 //򵥵ʱ
{
	for(; nCount != 0; nCount--);
}

/*
 * eeprom AT24C02 д
 */
void ee_Test(void)
{
  uint16_t i;
	uint8_t write_buf[EE_SIZE];
  uint8_t read_buf[EE_SIZE];
  
/*-----------------------------------------------------------------------------------*/  
  if (ee_CheckOk() == 0)
	{
		/* ûм⵽EEPROM */
		printf("ûм⵽EEPROM!\r\n");
				
		while (1);	/* ͣ */
	}
/*------------------------------------------------------------------------------------*/  
  /* Ի */
	for (i = 0; i < EE_SIZE; i++)
	{		
		write_buf[i] = i;
	}
/*------------------------------------------------------------------------------------*/  
  if (ee_WriteBytes(write_buf, 0, EE_SIZE) == 0)
	{
		printf("дeeprom\r\n");
		return;
	}
	else
	{		
		printf("дeepromɹ\r\n");
	}
  
  /*д֮ҪʵʱȥȻ*/
  ee_Delay(0x0FFFFF);
/*-----------------------------------------------------------------------------------*/
  if (ee_ReadBytes(read_buf, 0, EE_SIZE) == 0)
	{
		printf("eeprom\r\n");
		return;
	}
	else
	{		
		printf("eepromɹ£\r\n");
	}
/*-----------------------------------------------------------------------------------*/  
  for (i = 0; i < EE_SIZE; i++)
	{
		if(read_buf[i] != write_buf[i])
		{
			printf("0x%02X ", read_buf[i]);
			printf(":EEPROMдݲһ");
			return;
		}
    printf(" %02X", read_buf[i]);
		
		if ((i & 15) == 15)
		{
			printf("\r\n");	
		}		
	}
  printf("eepromдԳɹ\r\n");
  while(1);
}
